#include <stdlib.h>
#include <stdio.h>

typedef struct lista_el {

   /* Dato della cella attuale. */
   int dato;
   
   /* Puntatore all'elemento successivo nella lista */
   struct lista_el *succ;
} elemento;

/* stampa gli elementi nella lista dal primo all'ultimo */
void stampa_lista(elemento * curr) {
    if(curr == NULL) { 
	printf("NULL");
	return;
    }
  
    printf("%d -> ", curr->dato);
    stampa_lista(curr->succ);
}

/* stampa gli elementi della lista in ordine inverso */
void stampa_lista_reverse(elemento * curr) {
    if(curr == NULL) { 
	printf("NULL");
	return;
    }

    stampa_lista_reverse(curr->succ);
    printf(" <- %d", curr->dato);
}

/* costruisci_lista: dato un intero n,
 * legge n interi da stdin e
 * li organizza in una lista secondo
 * l'ordine di inserimento. 
 * ritorna la testa della nuova lista. 
 */
elemento *costruisci_lista ( int n )
{
   int i;
   /* testa rappresenta la testa della lista, il primo elemento inserito.
    * coda e' un puntatore all'ultimo elemento.
    * nuovo e' l'elemento che stiamo per inserire.
    */
   elemento *testa, *coda, *nuovo;
   
   /* all'inizio tutto vuoto */
   testa = coda = nuovo = NULL;

   for ( i = 0; i < n; i++ )  
   {
        /* alloco memoria per il prossimo */
        nuovo = (elemento *)malloc(sizeof(elemento));        

        /* ne leggo il campo dato da tastiera */
        scanf("%d", & ( nuovo->dato ) );
        /* inserisco in coda, quindi non ha successore. */
        nuovo->succ = NULL;

        /* la coda del passo precedente ha ora come successore
         * il nuovo elemento. */
        if ( coda != NULL ) 
           coda->succ = nuovo;
        /* e la coda avanza. */
        coda = nuovo;
 
        /* ricordiamoci che il primo elemento che inseriamo
         * e' la testa. */
        if ( testa == NULL ) 
             testa = nuovo;
   }

   return testa;
}



int main() {
   elemento * testa = NULL;
   int i, n, val;

   // Legge il numero di elementi 
   scanf("%d", &n);
   if(n < 1) return 1;

   testa = costruisci_lista ( n );
  
   stampa_lista(testa);
   printf("\n");
   stampa_lista_reverse(testa);
   printf("\n");
   return 0;

}
